// listbase.cpp

#include <iostream.h>
#include <new.h>

// abstract class
class dNode {
		dNode *_next;
		dNode *_prev;
	public:
		dNode();
		~dNode();
		void link(dNode &other);
		dNode *next();
		dNode *prev();
		virtual void print(ostream &stream)=0;
};

dNode::dNode()
{
	_next = _prev = 0;
}

dNode::~dNode() { }

void dNode::link(dNode &other)
{
	_next = &other;
	other._prev = this;
}

dNode *dNode::next() { return _next; }

dNode *dNode::prev() { return _prev; }

#define front 1;
#define back 2;

// ***
// *** DList HAS-A dNODE ***
// *************************
class DList {
		dNode *_head;
		dNode *_tail;
		short append;
	public:
		DList();
		~DList();
		// insert into list
		DList &operator << (dNode *op);
//		DList &operator << (short manipulator);
		dNode *head() { return _head; }
		dNode *tail() { return _tail; }
		friend ostream &operator << (ostream &stream, DList &other);
};

DList::DList()
{
	_head = _tail = 0;
	append = 1;
}

DList::~DList() { }

DList &DList::operator << (dNode *op)
{
	if (append)
	{
		if (_tail)
		{
			_tail->link(*op);
			_tail = op;
		}
		else
		{
			// first node
			_head = op;
			_tail = op;
		}
	}
	else
	{
		/* prepend */
		cout << "prepending" << endl;
	}
	return *this;
}

// ***
// *** intNode IS-A dNode ***
// **************************
class intNode : public dNode {
		int _data;
	public:
		intNode() { }
		~intNode() { }
		intNode(int indata) { _data = indata; }
		void print(ostream &stream) { stream << _data; }
};

ostream &operator << (ostream &stream, DList &other)
{
	dNode *traverse=0;
	int cnt=0;
	for (traverse = other._head; traverse; traverse = traverse->next())
	{
		traverse->print(stream);
		stream << " ";
		cnt++;
		if (cnt && !(cnt % 5))
			stream << endl;
	}
	return stream;
}

void exhausted()
{
	cout << "Free Store is exhausted." << endl;
}

void main()
{
	dNode *ip=0;
	DList mylist;
	
	set_new_handler(exhausted);
	mylist << new intNode(10) << new intNode(20) << new intNode(30);

	ip = new intNode(40);
	mylist << ip;
	ip = new intNode(50);
	mylist << ip;
	ip = new intNode(60);
	mylist << ip;
	
	cout << "mylist: " << endl;
	cout << mylist;	
}

