// mangle.cpp
#include <iostream.h>
#include <string.h>

#include "dynstrlb.h"
#include "PPbuf.h"

const int TBLMAX = 10;

void *operator new(size_t sz, void *p) 
{ 
	cout << "size is " << sz << endl;
	cout << "p is " << p << endl;
	return p; 
}
// we will handle only a subset of types
struct associate {
	char type[32];
	char replace[32];
} table[] = { { "int", "i" },
			  { "float", "f" },
			  { "long", "l" },
			  { "short", "s" },
			  { "char" , "c" },
			  { "int*", "ip" },
			  { "float*", "fp" },
			  { "long*", "lp" },
			  { "short*", "sp"},
			  { "char*", "cp" } };


String tbl_match(String word)
{
	int i=0;
	for (i=0; i < TBLMAX; i++)
	{
		if (word == table[i].type)
			break;
	}
	
	if (i == TBLMAX)
		return String("~BAD~");
	
	return String(table[i].replace);
}

String mangle(String prototype)
{
	String tmp,tmp1,tmp2,strip;
	int i=0,pos=0,len=0;
	
	pos = prototype.Strindex("(");
	if (pos < 0)
	{
		cout << "Prototype is not a function!" << endl;
		return 0;
	}
	
	tmp1 = prototype.Substr(1,pos);
	strip = prototype.Substr(pos+2,prototype.getlen()	- pos);

	PPbuf tokens(strip," \n");  // tokenize
	len = tokens.size();
	for (i=0; i < len; i ++)
	{
		tmp2 = tbl_match(tokens[i]);
		if (tmp2 != "~BAD~")
		{
			tmp1 = tmp1 + "_";
			tmp1 = tmp1 + tmp2;
		}
	}
	
	
	tmp = tmp1;
	
	return tmp;
}

void main()
{
	int done=0;
	String proto,result;
	
	while (!done)
	{
		cout << "Enter function prototype (or 'exit'): ";
		proto.getline(cin);
		if (proto == "exit")
		{
			done = 1;
		}
		else
		{
			result = mangle(proto);
			if (result.getlen())	
				cout << "mangled proto : " << result << endl;
		}
	}
}
