#include <iostream.h>
#include <new.h>
#include <assert.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

#include "listlib.h"
#include "arraylib.h"

class customer {
   int customer_number;
   int customer_input;
   int (*fp)(int);
public:
   customer();
   ~customer();
   customer(int custnum, int input, int (*action)(int));
   int getnumber();
   int getinput();
   int doaction();
   short operator == (customer &other);
   short operator > (customer &other);
   friend ostream &operator << (ostream &stream, customer &obj);
};

customer::customer()
{
   customer_number = customer_input = 0;
   fp = 0;
}

customer::~customer()
{
   customer_number = customer_input = 0;
   fp = 0;
}

customer::customer(int custnum,
		   int input, int (*action)(int))
{
   customer_number = custnum;
   customer_input = input;
   fp = action;
}

int customer::getnumber()
{
   return customer_number;
}

int customer::getinput()
{
   return customer_input;
}

int customer::doaction()
{
   int time_elapsed = fp(customer_input);
   return time_elapsed;
}

short customer::operator == (customer &other)
{
   if (customer_number == other.customer_number)
      return 1;
   else
      return 0;
}

short customer::operator > (customer &other)
{
   if (customer_number > other.customer_number)
      return 1;
   else
      return 0;
}

ostream &operator << (ostream &stream, customer &obj)
{
   stream << "Customer # " << obj.customer_number;
   obj.fp(obj.customer_input);
   return stream;
}

ostream &operator << (ostream &stream, Node<customer> &obj)
{
   stream << "Customer # " << obj.data.getnumber();
   obj.data.doaction();
   return stream;
}

class teller {
   customer current;
   int busy;
   int time_when_done;
public:
   teller();
   ~teller();
   customer imHelping();
   int iamBusy();
   int doneAt();
   void setBusy(int flag);
   void setTime(int time);
   customer &takeCustomer();
};

teller::teller()
{
	busy=0;
	time_when_done=0;
}

teller::~teller()
{
	busy=0;
	time_when_done=0;
}

customer teller::imHelping()
{
	return current;
}

int teller::iamBusy()
{
	return busy;
}

int teller::doneAt()
{
	return time_when_done;
}

customer &teller::takeCustomer()
{
	return current;
}

void teller::setBusy(int flag)
{
	busy = flag;
}

void teller::setTime(int time)
{
	time_when_done = time;
}

int unit_of_time(int cur_time)
{
	int i;
        /* if the unit_of_time is too slow or fast,
           you may replace it with a platform-specific
           time function like sleep() or wait() */
	for (i=0; i < 20000; i++)
          ;
        return(cur_time + 1);
}

int number_between(int min, int max)
{
   int roll = rand();
   int interval=0;
   int pick=0;

   if (max <= min)
	return(min);

   max++;
   interval = RAND_MAX/(max-min);
   pick = roll/interval;
   return(min+pick);
}

int say_hi_to_teller(int words_to_say)
{
	int blab_factor;

	cout << " saying hi to the teller.";
        blab_factor = number_between(1,words_to_say);
        return(blab_factor);
}

int cash_paycheck(int cash_to_count)
{
	cout << " cashing a paycheck.";
	return(15 + cash_to_count);
}

int open_account(int number_to_open)
{
	cout << " opening an account.";
   	return(number_to_open * 5);	 
}

int close_account(int number_to_close)
{
	cout << " closing an account.";
	return(number_to_close * 2);
}

int rob_bank(int number_helpers)
{
    cout << " robbing the bank.";
 	return(30-number_helpers);
}

void may_i_help_you(teller *tellers, List<customer> &the_line,
                    int now,int number_of_tellers)
{
  	int i;
    
	for (i=0; i < number_of_tellers; i++)
    {
       if ( (!(tellers[i].iamBusy())) && the_line.nodecnt())
 	   {
          /* pop a customer */
	      tellers[i].takeCustomer() = the_line.remove();
		
	      /* set busy flag and time_when_done */
 	      tellers[i].setBusy(1);
          cout << "Teller #" << i << " helps Customer #" << 
                   tellers[i].imHelping().getnumber() <<
                   " with ";
	      tellers[i].setTime((tellers[i].imHelping().doaction())
	                         + now);
	      cout << endl;
	   }
       else
       {
          /* check if we can release it */
	      if (now == tellers[i].doneAt())
	      {
             cout << "Teller #" << i << " says Goodbye to Customer #" << 
                         tellers[i].imHelping().getnumber() << endl;
		     tellers[i].setBusy(0);
	      }
       }
    }
}

#ifdef __SC__
#pragma template_access public
#pragma template Node<customer>
#pragma template List<customer>
#pragma template operator <<(ostream&,List<customer>&)
#pragma template compare(customer,customer);
#endif

int (*fp_array[5])(int) = {say_hi_to_teller,cash_paycheck,open_account,
                           close_account,rob_bank};

int input_array[5] = {20,50,3,2,5};

const int MAXcustomers = 30;

void exhausted()
{
	cout << "Exhausted the heap!" << endl;
	exit(0);
}

int main()
{
	int customers_left = MAXcustomers,ThisCustomer=0;
	int interval = 10; /* 10 units of time */
	int start_time =0, current_time,last_entry;
	int opened_door = 1,task=0,num_tellers=0;
	int max_size=0,size=0;
	List<customer> customer_line;
   
    set_new_handler(exhausted);
    
	cout << "Enter number of tellers on duty: ";
	cin >> num_tellers;
   
   teller *the_tellers = new teller[num_tellers];

	srand(89137);

	current_time = start_time;

	while (customers_left)
	{
		if (opened_door)
		{
			ThisCustomer = MAXcustomers-customers_left;
			cout << "Customer #" << ThisCustomer 
			     << " Entered the Bank." << endl;
			opened_door = 0;
			last_entry = current_time;
			// determine what the customer will do.
			task = number_between(0,4);
      		customer_line.insert(customer(ThisCustomer,
      		                              number_between(0,
      		                              input_array[task]),
      		                              fp_array[task]));
		}
		
    	current_time = unit_of_time(current_time);

		may_i_help_you(the_tellers,
					   customer_line,current_time,num_tellers);
    
    	if (current_time == (last_entry + interval))
    	{
			opened_door = 1;
			customers_left--;
      		cout << "-------------Bank line-------------" << endl;
      		cout << customer_line;
      		size = customer_line.nodecnt();
      		if (size > max_size)
      			max_size = size;
     		 cout << "-----------------------------------" << endl;
    	}    
  }
  
  cout << "At the end of the day," << endl <<
          " the maximum number of waiting customers was " << 
          max_size << "." << endl;
  return 0;
}
