// memtest2.cpp
#include <iostream.h>
#include <string.h>
#include <ctype.h>

#include "dbgnew.h"
#include "dynstrlb.h"

const int SIZE = 100;
String *Strings[SIZE];

int main()
{
	String *c1=0, *c2=0, *c3=0, *c4=0;
	String *never_malloced;
	int i;
	String Overwrite("this is a string too long to be stuffed into c1.");
	char Stuff[80];
	
	// simple case - allocating String classes with new
	strcpy(Stuff,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
	cout << "Case 1: Allocating String classes.\n";
	for (i=0; i < 100; i++)
		Strings[i] = new String(Stuff);
		
	memory_map();
	memory_dump();
	print_free_list();	
	print_stats();
	
	// free every other String - no coalescing
	cout << "Case 2: deleting Strings. NO COALESCING." << endl;
	for (i=0; i < 100; i += 2) // even blocks
		delete Strings[i];
	memory_map();
	memory_dump();
	print_free_list();
	print_stats();

	// coalesce everything
	cout << "Case 3: deleting strings with COALESCING." << endl;
	for (i=1; i < 100; i += 2) // odd blocks
		delete Strings[i];
	memory_map();
	memory_dump();
	print_free_list();
	print_stats();
	
	cout << "Case 5: check the heap for corruption. Should be good.\n";
	if (!check_heap())
		cout << "HEAP IS CORRUPTED!\n";
	else
		cout << "HEAP IS OK!\n";
		
	cout << "case 6: corrupt the heap!\n";
	
	// we will corrupt the heap by overwriting c3.
	c2 = new String("this is string2.");
	c3 = new String("this is string3.");
	c4 = new String("this is string4.");
	*c2 = Overwrite;
				
	if (!check_heap())
		cout << "HEAP IS CORRUPTED!\n";
	else
		cout << "HEAP IS OK!\n";
	memory_map();
	memory_dump();
	print_free_list();	
	print_stats();	

	return 0;
}
