// address_operator.cpp
#include <iostream.h>
#include <iomanip.h>

void main()
{
	char mychar;
	int myint;
	char *char_ptr;
	int *int_ptr;
	void *void_ptr;

	/* when you define variables in a program (pointers included) 
	the compiler sets aside the correct amount of memory for those variables.  
	Since the compiler has assigned memory locations (and addresses) 
	to the variables you can be sure that defined variables have addresses. 
	To assign an address to a pointer variable you use an assignment statement 
	and the address operator (&). */
	mychar = 'm';
	char_ptr = &mychar;
	cout << "mychar is " << mychar << endl;
	cout << "the address of mychar is " << (void *)&mychar << endl;
	// NOTE: casting the address to a void pointer is necessary only for streams
	// If we used printf() it would not be necessary.
	cout << "char_ptr is also " << (void *)char_ptr << endl;
	cout << "char_ptr points to " << *char_ptr << endl;
}
